package com.johan.morseCode1;


import android.content.SharedPreferences;
import android.widget.Toast;


import android.hardware.Camera;
import android.hardware.Camera.Parameters;
import android.util.Log;
import android.content.Context;
import android.os.Build;
import android.annotation.TargetApi;
import android.widget.Toast;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;


import java.lang.*; 

import java.io.IOException;
import java.util.List;

import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Hide;


@ShortName("B4AMorseCode1")
@TargetApi(Build.VERSION_CODES.ICE_CREAM_SANDWICH_MR1)



//public class morseCode1 extends Activity {
public class morseCode1 {
	String morsecode;
	String inputtext;
	String currMorse;
        String flashRate;  
        Handler handler = null;   //added on 15 Jan 2015
	
	Camera mCamera;
	Camera.Parameters mParameters;
	//private boolean mbTorchEnabled = false;
	Thread outThread;
        Thread toastOutThread;
	int dit, dah; // dit = "."    dah = "-"  
	boolean notavailable = false;

	
/**
* 
*Flashes a Morse Code message via the rear camera flash
* 
*myMorseString = The input string to be converted to Morse Code
*myRate = The flashing rate (specify "Fast", "Medium", "Slow", or "Ultra Slow")
* 
*Example:<code>
*Dim mmc As B4AMorseCode1
*
*mmc.transmitMorse("SOS SOS SOS SOS","Slow")
*</code>
* 
*/
	public void transmitMorse (final BA ba, String myMorseString, String myRate) {
		             
	                     myMorseString = stringConvert(myMorseString);
                             morsecode = myMorseString;
                             BA.Log(morsecode);
                             currMorse = "";
                             flashRate = myRate; 

                             //*****************added from here on 1 Jan 2015****************** 
                             //create a handler to display the transmission completed message at the end of transmission
                             handler=new Handler() {
                               @Override public void handleMessage(Message msg) {
                                  Toast.makeText(ba.context.getApplicationContext(),"Morse code transmission completed",Toast.LENGTH_SHORT).show();
                               }
                             };
                             //*****************added to here on 1 Jan 2015******************

				try
				{
					mCamera = Camera.open();
				
				
				//... later in a click handler or other location
				//Get camera parameters
				mParameters = mCamera.getParameters();
				 
				//Get supported flash modes
				List flashModes = mParameters.getSupportedFlashModes ();
				 
				//Make sure that torch mode is supported
				if(flashModes != null && flashModes.contains("torch"))
				{
				    
				//Start Thread to activate Camera
			    	outThread = new Thread( new FlashOutRunnable() );
			    	if (!outThread.isAlive())         
			    		outThread.start();

                                        //Display a toast message
                                        CharSequence text = "Morse code transmission in progress";
                                        int duration = Toast.LENGTH_SHORT;
                                        Toast.makeText(ba.context.getApplicationContext(), text, duration).show();    
                         
			    	
			        
				}else
				{
					notavailable = true;
					Toast.makeText( ba.context.getApplicationContext(),
							 "Flash light not supported",
							 Toast.LENGTH_SHORT).show();
				}
					 
				}catch (Exception e)
				{
					if (notavailable)
						{
							Toast.makeText( ba.context.getApplicationContext(),
									"Not available on this device",
							 Toast.LENGTH_SHORT).show();
						}
//					e.printStackTrace();
				}
		
	}
	
	
	
	
	public class FlashOutRunnable implements Runnable 
	{

		public void run() 
		{
//			Log.i("FlashDisView-Thread","Thread started, in: " + inputtext);

    		// Short pause before start 
    		try {
				Thread.sleep(800);
			} catch (InterruptedException e1) {
//				e1.printStackTrace();
			}
			
			
    		
    		// output for every morsecode-char
                        if (flashRate.equals("Fast")) 
                        { 
                          dit = 100;
                          dah = 300;
                        }
                        if (flashRate.equals("Medium")) 
                        { 
                          dit = 150;
                          dah = 450;
                        }
                        if (flashRate.equals("Slow")) 
                        { 
                          dit = 200;
                          dah = 600;
                        }
                        if (flashRate.equals("Ultra Slow")) 
                        { 
                          dit = 300;
                          dah = 900;
                        }
  
			for (int i=0; i<morsecode.length(); i++)
			{
				if (currMorse.length() < morsecode.length()) 
					currMorse = currMorse + morsecode.substring(i,i+1); 
				if (morsecode.substring(i,i+1).equals(".")) // dit
				{
                                        BA.Log("Got dit");
					mParameters.setFlashMode(Camera.Parameters.FLASH_MODE_TORCH);
					mCamera.setParameters(mParameters);
                                        mCamera.startPreview();
					
					try {
						Thread.sleep(dit);
						mParameters.setFlashMode(Camera.Parameters.FLASH_MODE_OFF);
						mCamera.setParameters(mParameters);
						Thread.sleep(dit); // abstand zwischen zwei symbolen ist ein dit lang
					} catch (InterruptedException e) {
						e.printStackTrace();
						mParameters.setFlashMode(Camera.Parameters.FLASH_MODE_OFF);
						mCamera.setParameters(mParameters);
					}
				}
				if (morsecode.substring(i,i+1).equals("-")) // dah
				{
                                        BA.Log("Got dah");
					mParameters.setFlashMode(Camera.Parameters.FLASH_MODE_TORCH);
					mCamera.setParameters(mParameters);
                                        mCamera.startPreview(); 
					try {
						Thread.sleep(dah);
						mParameters.setFlashMode(Camera.Parameters.FLASH_MODE_OFF);
						mCamera.setParameters(mParameters);
						Thread.sleep(dit); // abstand zwischen zwei symbolen ist ein dit lang
					} catch (InterruptedException e) {
						e.printStackTrace();
						mParameters.setFlashMode(Camera.Parameters.FLASH_MODE_OFF);
						mCamera.setParameters(mParameters);
					}
				}
	        	     if (morsecode.substring(i,i+1).equals(" ")) // space zwischen zwei buchstaben
	        	     {
	        		     try {
				    		Thread.sleep(dah); //zwischen Buchstaben in einem Wort wird ein dah (=3dit) Abstand gelassen 
					} catch (InterruptedException e) {
//						e.printStackTrace();
					}
			     }
	        	     if (morsecode.substring(i,i+1).equals("|")) // abstand zwischen zwei wrtern "\"
	        	     {
	        		try {
						Thread.sleep(dit*7); //zwischen Wrtern wird eine Pause von sieben dits gemacht.
					} catch (InterruptedException e) {
//						e.printStackTrace();
					}
			     }	     
			}
			
			//Switch off flash at the end
			mParameters.setFlashMode(Camera.Parameters.FLASH_MODE_OFF);
		        mCamera.setParameters(mParameters);
			
			// free camera for other applications
			mCamera.release();

			toastOutThread = new Thread( new ToastOutRunnable() );
			if (!toastOutThread.isAlive())         
			  toastOutThread.start();
                 
		}
	}


        //*****************added from here on 1 Jan 2015****************** 
        //  Create a new runnable to display the toast message once the morse code has been transmitted (transmission completed)
	public class ToastOutRunnable implements Runnable 
	{
                           public void run() {
                                   int myflag = 0;                  //establish a reason to break the new thread that we have created
                                   while(!Thread.interrupted())
                                   {
                                       myflag = myflag + 1;
                                          
                                       Message msg=new Message();
                                       msg.obj="your text";
                                       handler.sendMessage(msg);
                                        try {
                                            Thread.sleep(0);       //no reason to sleep here - message display time 
                                                                   //is determined by the call to display the toast message.    
                                            if (myflag == 1)       //break the thread as it is no longer required and myflag is now = 1
                                               break;
                                        } 
                                        catch (InterruptedException e) {
                                           e.printStackTrace();
                                        }
                                   }
                           }
       }
       //*****************added to here on 1 Jan 2015****************** 
	
@Hide
public static String stringConvert(String userString) {
    String currentChar;
    String getMorseChar;
    String convertedString = "";

    for (int i = 0; i < userString.length(); i++)
    {
        //Get character at i position
        currentChar = userString.charAt(i) + "";  

        //convert character to morse code
        getMorseChar = convert(currentChar);

        //seperate words with the | symbol
        if (getMorseChar.equals(" "))
        {
            convertedString = convertedString + "  |  ";
        } 

        else 
        {
            //concat the converted letter
            convertedString = convertedString + getMorseChar;

            //Add a space between each letter
            if (!getMorseChar.equals(" ")) 
            {
                convertedString = convertedString + " ";
            }   
        }           
    }
//  BA.Log(convertedString);
    return convertedString;

}

 @Hide
 public static String convert (String toEncode) {  
        String morse = toEncode;  

        if (toEncode.equalsIgnoreCase("a"))  
            morse = ".-";  
        if (toEncode.equalsIgnoreCase("b"))  
            morse = "-...";  
        if (toEncode.equalsIgnoreCase("c"))  
            morse = "-.-.";  
        if (toEncode.equalsIgnoreCase("d"))  
            morse = "-..";  
        if (toEncode.equalsIgnoreCase("e"))  
            morse = ".";  
        if (toEncode.equalsIgnoreCase("f"))  
            morse = "..-.";  
        if (toEncode.equalsIgnoreCase("g"))  
            morse = "--.";  
        if (toEncode.equalsIgnoreCase("h"))  
            morse = "....";  
        if (toEncode.equalsIgnoreCase("i"))  
            morse = "..";  
        if (toEncode.equalsIgnoreCase("j"))  
            morse = ".---";  
        if (toEncode.equalsIgnoreCase("k"))  
            morse = "-.-";  
        if (toEncode.equalsIgnoreCase("l"))  
            morse = ".-..";  
        if (toEncode.equalsIgnoreCase("m"))  
            morse = "--";  
        if (toEncode.equalsIgnoreCase("n"))  
            morse = "-.";  
        if (toEncode.equalsIgnoreCase("o"))  
            morse = "---";  
        if (toEncode.equalsIgnoreCase("p"))  
            morse = ".--.";  
        if (toEncode.equalsIgnoreCase("q"))  
            morse = "--.-";  
        if (toEncode.equalsIgnoreCase("r"))  
            morse = ".-.";  
        if (toEncode.equalsIgnoreCase("s"))  
            morse = "...";  
        if (toEncode.equalsIgnoreCase("t"))  
            morse = "-";  
        if (toEncode.equalsIgnoreCase("u"))  
            morse = "..-";  
        if (toEncode.equalsIgnoreCase("v"))  
            morse = "...-";  
        if (toEncode.equalsIgnoreCase("w"))  
            morse = ".--";  
        if (toEncode.equalsIgnoreCase("x"))  
            morse = "-..-";  
        if (toEncode.equalsIgnoreCase("y"))  
            morse = "-.--";  
        if (toEncode.equalsIgnoreCase("z"))  
            morse = "--..";  
        if (toEncode.equalsIgnoreCase("0"))  
            morse = "-----";  
        if (toEncode.equalsIgnoreCase("1"))  
            morse = ".----";  
        if (toEncode.equalsIgnoreCase("2"))  
            morse = "..---";  
        if (toEncode.equalsIgnoreCase("3"))  
            morse = "...--";  
        if (toEncode.equalsIgnoreCase("4"))  
            morse = "....-";  
        if (toEncode.equalsIgnoreCase("5"))  
            morse = ".....";  
        if (toEncode.equalsIgnoreCase("6"))  
            morse = "-....";  
        if (toEncode.equalsIgnoreCase("7"))  
            morse = "--...";  
        if (toEncode.equalsIgnoreCase("8"))  
            morse = "---..";  
        if (toEncode.equalsIgnoreCase("9"))  
            morse = "----.";  
        if (toEncode.equalsIgnoreCase("."))  
            morse = ".-.-.-";  
        if (toEncode.equalsIgnoreCase(","))  
            morse = "--..--";  
        if (toEncode.equalsIgnoreCase("?"))  
            morse = "..--..";  
        if (toEncode.equalsIgnoreCase("!"))  
            morse = "-.-.--";  
        if (toEncode.equalsIgnoreCase("/"))  
            morse = "-..-.";  
        if (toEncode.equalsIgnoreCase("("))  
            morse = "-.--.";  
        if (toEncode.equalsIgnoreCase(")"))  
            morse = "-.--.-";
        if (toEncode.equalsIgnoreCase("&"))  
            morse = ".-...";   
        if (toEncode.equalsIgnoreCase(":"))  
            morse = "---...";
        if (toEncode.equalsIgnoreCase("="))  
            morse = "-...-";   
        if (toEncode.equalsIgnoreCase("+"))  
            morse = ".-.-.";
        if (toEncode.equalsIgnoreCase("-"))  
            morse = "-....-";  
        if (toEncode.equalsIgnoreCase("_"))  
            morse = "..--.-";   
        if (toEncode.equalsIgnoreCase("$"))  
            morse = "...-..-"; 
        if (toEncode.equalsIgnoreCase("@"))  
            morse = ".--.-.";    

        return morse;  
    }  
     

//end of class
}  


